
_main:

;Automatic_Temp_Control.c,38 :: 		void main() {
;Automatic_Temp_Control.c,45 :: 		Keypad_Init();                           // Initialize Keypad
	CALL        _Keypad_Init+0, 0
;Automatic_Temp_Control.c,46 :: 		ANSELC = 0;                              // Configure PORTC as digital I/O
	CLRF        ANSELC+0 
;Automatic_Temp_Control.c,47 :: 		ANSELB = 0;                              // Configure PORTB as digital I/O
	CLRF        ANSELB+0 
;Automatic_Temp_Control.c,48 :: 		ANSELD = 0;                              // Configure PORTD as digital I/O
	CLRF        ANSELD+0 
;Automatic_Temp_Control.c,49 :: 		TRISA0_bit = 1;                          //Configure AN0 (RA0) as input
	BSF         TRISA0_bit+0, BitPos(TRISA0_bit+0) 
;Automatic_Temp_Control.c,50 :: 		TRISC = 0;                               //PORTC are outputs (LCD)
	CLRF        TRISC+0 
;Automatic_Temp_Control.c,51 :: 		TRISD0_bit=0;                            //RD0 is output (Heater)
	BCF         TRISD0_bit+0, BitPos(TRISD0_bit+0) 
;Automatic_Temp_Control.c,52 :: 		TRISD1_bit=0;                            //RD1 is output (Fan)
	BCF         TRISD1_bit+0, BitPos(TRISD1_bit+0) 
;Automatic_Temp_Control.c,54 :: 		Lcd_Init();                              // Initialize LCD
	CALL        _Lcd_Init+0, 0
;Automatic_Temp_Control.c,55 :: 		Lcd_Cmd(_LCD_CLEAR);                     // Clear display
	MOVLW       1
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;Automatic_Temp_Control.c,56 :: 		Lcd_Cmd(_LCD_CURSOR_OFF);                // Cursor off
	MOVLW       12
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;Automatic_Temp_Control.c,57 :: 		Lcd_Out(1, 4, "Automatic");
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       4
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr1_Automatic_Temp_Control+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr1_Automatic_Temp_Control+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;Automatic_Temp_Control.c,58 :: 		Lcd_Out(2, 2, "Temp Control");
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       2
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr2_Automatic_Temp_Control+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr2_Automatic_Temp_Control+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;Automatic_Temp_Control.c,59 :: 		delay_ms(2000);                          //2s delay
	MOVLW       21
	MOVWF       R11, 0
	MOVLW       75
	MOVWF       R12, 0
	MOVLW       190
	MOVWF       R13, 0
L_main0:
	DECFSZ      R13, 1, 1
	BRA         L_main0
	DECFSZ      R12, 1, 1
	BRA         L_main0
	DECFSZ      R11, 1, 1
	BRA         L_main0
	NOP
;Automatic_Temp_Control.c,61 :: 		HEATER = OFF;
	BCF         PORTD+0, 0 
;Automatic_Temp_Control.c,62 :: 		FAN = OFF;
	BCF         PORTD+0, 1 
;Automatic_Temp_Control.c,65 :: 		START:
___main_START:
;Automatic_Temp_Control.c,66 :: 		Lcd_Cmd(_LCD_CLEAR);                     // Clear display
	MOVLW       1
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;Automatic_Temp_Control.c,67 :: 		Lcd_Out(1, 1, "Enter Temp Ref");
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr3_Automatic_Temp_Control+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr3_Automatic_Temp_Control+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;Automatic_Temp_Control.c,68 :: 		Temp_Ref=0;
	CLRF        main_Temp_Ref_L0+0 
;Automatic_Temp_Control.c,69 :: 		Lcd_Out(2, 1, "Temp Ref: ");
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr4_Automatic_Temp_Control+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr4_Automatic_Temp_Control+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;Automatic_Temp_Control.c,70 :: 		while(1)
L_main1:
;Automatic_Temp_Control.c,72 :: 		do
L_main3:
;Automatic_Temp_Control.c,73 :: 		kp = Keypad_Key_Click();             // Store key code in kp variable
	CALL        _Keypad_Key_Click+0, 0
	MOVF        R0, 0 
	MOVWF       main_kp_L0+0 
;Automatic_Temp_Control.c,74 :: 		while (!kp);
	MOVF        R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_main3
;Automatic_Temp_Control.c,75 :: 		if ( kp == ENTER )break;
	MOVF        main_kp_L0+0, 0 
	XORLW       15
	BTFSS       STATUS+0, 2 
	GOTO        L_main6
	GOTO        L_main2
L_main6:
;Automatic_Temp_Control.c,76 :: 		if (kp > 3 && kp < 8) kp = kp-1;
	MOVF        main_kp_L0+0, 0 
	SUBLW       3
	BTFSC       STATUS+0, 0 
	GOTO        L_main9
	MOVLW       8
	SUBWF       main_kp_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_main9
L__main27:
	DECF        main_kp_L0+0, 1 
L_main9:
;Automatic_Temp_Control.c,77 :: 		if (kp > 8 && kp < 12) kp = kp-2;
	MOVF        main_kp_L0+0, 0 
	SUBLW       8
	BTFSC       STATUS+0, 0 
	GOTO        L_main12
	MOVLW       12
	SUBWF       main_kp_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_main12
L__main26:
	MOVLW       2
	SUBWF       main_kp_L0+0, 1 
L_main12:
;Automatic_Temp_Control.c,78 :: 		if (kp ==14)kp = 0;
	MOVF        main_kp_L0+0, 0 
	XORLW       14
	BTFSS       STATUS+0, 2 
	GOTO        L_main13
	CLRF        main_kp_L0+0 
L_main13:
;Automatic_Temp_Control.c,79 :: 		if ( kp == CLEAR )goto START;
	MOVF        main_kp_L0+0, 0 
	XORLW       13
	BTFSS       STATUS+0, 2 
	GOTO        L_main14
	GOTO        ___main_START
L_main14:
;Automatic_Temp_Control.c,80 :: 		Lcd_Chr_Cp(kp + '0');
	MOVLW       48
	ADDWF       main_kp_L0+0, 0 
	MOVWF       FARG_Lcd_Chr_CP_out_char+0 
	CALL        _Lcd_Chr_CP+0, 0
;Automatic_Temp_Control.c,81 :: 		Temp_Ref =(10*Temp_Ref) + kp;
	MOVLW       10
	MULWF       main_Temp_Ref_L0+0 
	MOVF        PRODL+0, 0 
	MOVWF       main_Temp_Ref_L0+0 
	MOVF        main_kp_L0+0, 0 
	ADDWF       main_Temp_Ref_L0+0, 1 
;Automatic_Temp_Control.c,82 :: 		}
	GOTO        L_main1
L_main2:
;Automatic_Temp_Control.c,83 :: 		Lcd_Cmd(_LCD_CLEAR);                     // Clear display
	MOVLW       1
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;Automatic_Temp_Control.c,84 :: 		Lcd_Out(1, 1, "Temp Ref: ");
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr5_Automatic_Temp_Control+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr5_Automatic_Temp_Control+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;Automatic_Temp_Control.c,85 :: 		intToStr( Temp_Ref,Txt);         //Convert to String
	MOVF        main_Temp_Ref_L0+0, 0 
	MOVWF       FARG_IntToStr_input+0 
	MOVLW       0
	MOVWF       FARG_IntToStr_input+1 
	MOVLW       main_Txt_L0+0
	MOVWF       FARG_IntToStr_output+0 
	MOVLW       hi_addr(main_Txt_L0+0)
	MOVWF       FARG_IntToStr_output+1 
	CALL        _IntToStr+0, 0
;Automatic_Temp_Control.c,86 :: 		inTemp=Ltrim(Txt);
	MOVLW       main_Txt_L0+0
	MOVWF       FARG_Ltrim_string+0 
	MOVLW       hi_addr(main_Txt_L0+0)
	MOVWF       FARG_Ltrim_string+1 
	CALL        _Ltrim+0, 0
;Automatic_Temp_Control.c,87 :: 		Lcd_Out_CP(inTemp);                  //Display Ref Temp
	MOVF        R0, 0 
	MOVWF       FARG_Lcd_Out_CP_text+0 
	MOVLW       0
	MOVWF       FARG_Lcd_Out_CP_text+1 
	CALL        _Lcd_Out_CP+0, 0
;Automatic_Temp_Control.c,88 :: 		Lcd_Out(2, 1, "Press # to Cont.");
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr6_Automatic_Temp_Control+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr6_Automatic_Temp_Control+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;Automatic_Temp_Control.c,90 :: 		kp =0;
	CLRF        main_kp_L0+0 
;Automatic_Temp_Control.c,91 :: 		while(kp!=ENTER)
L_main15:
	MOVF        main_kp_L0+0, 0 
	XORLW       15
	BTFSC       STATUS+0, 2 
	GOTO        L_main16
;Automatic_Temp_Control.c,93 :: 		do
L_main17:
;Automatic_Temp_Control.c,94 :: 		kp = Keypad_Key_Click();             // Store key code in kp variable
	CALL        _Keypad_Key_Click+0, 0
	MOVF        R0, 0 
	MOVWF       main_kp_L0+0 
;Automatic_Temp_Control.c,95 :: 		while(!kp);
	MOVF        R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_main17
;Automatic_Temp_Control.c,96 :: 		}
	GOTO        L_main15
L_main16:
;Automatic_Temp_Control.c,97 :: 		Lcd_Cmd(_LCD_CLEAR);              // Clear display
	MOVLW       1
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;Automatic_Temp_Control.c,99 :: 		Lcd_Out(1, 1, "Temp Ref: ");
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr7_Automatic_Temp_Control+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr7_Automatic_Temp_Control+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;Automatic_Temp_Control.c,100 :: 		Lcd_Chr(1,15,223);                  // Different LCD displays have different
	MOVLW       1
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       15
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVLW       223
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;Automatic_Temp_Control.c,102 :: 		Lcd_Chr(1,16,'C');                  // Display "C" for Celsius
	MOVLW       1
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       16
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVLW       67
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;Automatic_Temp_Control.c,104 :: 		while(1) {
L_main20:
;Automatic_Temp_Control.c,106 :: 		temp = ADC_Read(0);               //Read temperature from AN0
	CLRF        FARG_ADC_Read_channel+0 
	CALL        _ADC_Read+0, 0
;Automatic_Temp_Control.c,107 :: 		mV = temp * 5000.0/1024.0;        //Convert to mV
	CALL        _Word2Double+0, 0
	MOVLW       0
	MOVWF       R4 
	MOVLW       64
	MOVWF       R5 
	MOVLW       28
	MOVWF       R6 
	MOVLW       139
	MOVWF       R7 
	CALL        _Mul_32x32_FP+0, 0
	MOVLW       0
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	MOVLW       0
	MOVWF       R6 
	MOVLW       137
	MOVWF       R7 
	CALL        _Div_32x32_FP+0, 0
;Automatic_Temp_Control.c,108 :: 		ActualTemp = mV/10.0 ;              // Convert to degrees Celcius
	MOVLW       0
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	MOVLW       32
	MOVWF       R6 
	MOVLW       130
	MOVWF       R7 
	CALL        _Div_32x32_FP+0, 0
	MOVF        R0, 0 
	MOVWF       main_ActualTemp_L0+0 
	MOVF        R1, 0 
	MOVWF       main_ActualTemp_L0+1 
	MOVF        R2, 0 
	MOVWF       main_ActualTemp_L0+2 
	MOVF        R3, 0 
	MOVWF       main_ActualTemp_L0+3 
;Automatic_Temp_Control.c,109 :: 		intToStr( Temp_Ref,Txt);         //Convert to String
	MOVF        main_Temp_Ref_L0+0, 0 
	MOVWF       FARG_IntToStr_input+0 
	MOVLW       0
	MOVWF       FARG_IntToStr_input+1 
	MOVLW       main_Txt_L0+0
	MOVWF       FARG_IntToStr_output+0 
	MOVLW       hi_addr(main_Txt_L0+0)
	MOVWF       FARG_IntToStr_output+1 
	CALL        _IntToStr+0, 0
;Automatic_Temp_Control.c,110 :: 		inTemp=Ltrim(Txt);
	MOVLW       main_Txt_L0+0
	MOVWF       FARG_Ltrim_string+0 
	MOVLW       hi_addr(main_Txt_L0+0)
	MOVWF       FARG_Ltrim_string+1 
	CALL        _Ltrim+0, 0
;Automatic_Temp_Control.c,112 :: 		Lcd_Out(1, 11, inTemp);        //Display Ref Temp
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       11
	MOVWF       FARG_Lcd_Out_column+0 
	MOVF        R0, 0 
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       0
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;Automatic_Temp_Control.c,113 :: 		Lcd_Out(2, 1, "Temp= ");
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr8_Automatic_Temp_Control+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr8_Automatic_Temp_Control+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;Automatic_Temp_Control.c,114 :: 		FloatToStr(ActualTemp,Txt);         //Convert to string
	MOVF        main_ActualTemp_L0+0, 0 
	MOVWF       FARG_FloatToStr_fnum+0 
	MOVF        main_ActualTemp_L0+1, 0 
	MOVWF       FARG_FloatToStr_fnum+1 
	MOVF        main_ActualTemp_L0+2, 0 
	MOVWF       FARG_FloatToStr_fnum+2 
	MOVF        main_ActualTemp_L0+3, 0 
	MOVWF       FARG_FloatToStr_fnum+3 
	MOVLW       main_Txt_L0+0
	MOVWF       FARG_FloatToStr_str+0 
	MOVLW       hi_addr(main_Txt_L0+0)
	MOVWF       FARG_FloatToStr_str+1 
	CALL        _FloatToStr+0, 0
;Automatic_Temp_Control.c,115 :: 		Txt[4] = 0;
	CLRF        main_Txt_L0+4 
;Automatic_Temp_Control.c,116 :: 		Lcd_Out(2,7,Txt);
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       7
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       main_Txt_L0+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(main_Txt_L0+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;Automatic_Temp_Control.c,117 :: 		Lcd_Out(2,12,"   ");
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       12
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr9_Automatic_Temp_Control+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr9_Automatic_Temp_Control+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;Automatic_Temp_Control.c,120 :: 		if (Temp_Ref >  ActualTemp)  //If Temp Ref is less than actual Temp, Switch ON Heater
	MOVF        main_Temp_Ref_L0+0, 0 
	MOVWF       R0 
	CALL        _Byte2Double+0, 0
	MOVF        R0, 0 
	MOVWF       R4 
	MOVF        R1, 0 
	MOVWF       R5 
	MOVF        R2, 0 
	MOVWF       R6 
	MOVF        R3, 0 
	MOVWF       R7 
	MOVF        main_ActualTemp_L0+0, 0 
	MOVWF       R0 
	MOVF        main_ActualTemp_L0+1, 0 
	MOVWF       R1 
	MOVF        main_ActualTemp_L0+2, 0 
	MOVWF       R2 
	MOVF        main_ActualTemp_L0+3, 0 
	MOVWF       R3 
	CALL        _Compare_Double+0, 0
	MOVLW       1
	BTFSC       STATUS+0, 0 
	MOVLW       0
	MOVWF       R0 
	MOVF        R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_main22
;Automatic_Temp_Control.c,122 :: 		HEATER = ON,
	BSF         PORTD+0, 0 
;Automatic_Temp_Control.c,123 :: 		FAN = OFF;
	BCF         PORTD+0, 1 
;Automatic_Temp_Control.c,124 :: 		}
L_main22:
;Automatic_Temp_Control.c,125 :: 		if (Temp_Ref <  ActualTemp)  //If Temp Ref is greater than actual Temp, Switch ON Fan
	MOVF        main_Temp_Ref_L0+0, 0 
	MOVWF       R0 
	CALL        _Byte2Double+0, 0
	MOVF        main_ActualTemp_L0+0, 0 
	MOVWF       R4 
	MOVF        main_ActualTemp_L0+1, 0 
	MOVWF       R5 
	MOVF        main_ActualTemp_L0+2, 0 
	MOVWF       R6 
	MOVF        main_ActualTemp_L0+3, 0 
	MOVWF       R7 
	CALL        _Compare_Double+0, 0
	MOVLW       1
	BTFSC       STATUS+0, 0 
	MOVLW       0
	MOVWF       R0 
	MOVF        R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_main23
;Automatic_Temp_Control.c,127 :: 		HEATER = OFF,
	BCF         PORTD+0, 0 
;Automatic_Temp_Control.c,128 :: 		FAN = ON;
	BSF         PORTD+0, 1 
;Automatic_Temp_Control.c,129 :: 		}
L_main23:
;Automatic_Temp_Control.c,130 :: 		if (Temp_Ref ==  ActualTemp)  //If Temp Ref is equal to actual Temp, Switch OFF Fan and Heater
	MOVF        main_Temp_Ref_L0+0, 0 
	MOVWF       R0 
	CALL        _Byte2Double+0, 0
	MOVF        main_ActualTemp_L0+0, 0 
	MOVWF       R4 
	MOVF        main_ActualTemp_L0+1, 0 
	MOVWF       R5 
	MOVF        main_ActualTemp_L0+2, 0 
	MOVWF       R6 
	MOVF        main_ActualTemp_L0+3, 0 
	MOVWF       R7 
	CALL        _Equals_Double+0, 0
	MOVLW       1
	BTFSS       STATUS+0, 2 
	MOVLW       0
	MOVWF       R0 
	MOVF        R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_main24
;Automatic_Temp_Control.c,132 :: 		HEATER = OFF,
	BCF         PORTD+0, 0 
;Automatic_Temp_Control.c,133 :: 		FAN = OFF;
	BCF         PORTD+0, 1 
;Automatic_Temp_Control.c,134 :: 		}
L_main24:
;Automatic_Temp_Control.c,135 :: 		Delay_ms(10000);        //Wait 10 s then repeat
	MOVLW       102
	MOVWF       R11, 0
	MOVLW       118
	MOVWF       R12, 0
	MOVLW       193
	MOVWF       R13, 0
L_main25:
	DECFSZ      R13, 1, 1
	BRA         L_main25
	DECFSZ      R12, 1, 1
	BRA         L_main25
	DECFSZ      R11, 1, 1
	BRA         L_main25
;Automatic_Temp_Control.c,136 :: 		}
	GOTO        L_main20
;Automatic_Temp_Control.c,137 :: 		}
L_end_main:
	GOTO        $+0
; end of _main
